Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3298)
@@ -15,5 +15,5 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2018 Leibniz Universitaet Hannover
+! Copyright 2017-2018 Leibniz Universitaet Hannover
 ! Copyright 2017-2018 Karlsruhe Institute of Technology
 ! Copyright 2017-2018 Freie Universitaet Berlin
@@ -27,12 +27,47 @@
 ! -----------------
 ! $Id$
+! Add remarks (kanani)
+! Merge with trunk, replaced cloud_physics by bulk_cloud_model         28.09.2018 forkel
+! Subroutines header and chem_check_parameters added                   25.09.2018 basit
+! Removed chem_emission routine now declared in chem_emissions.f90     30.07.2018 ERUSSO
+! Introduced emissions namelist parameters                             30.07.2018 ERUSSO
+!
+! Timestep steering added in subroutine chem_integrate_ij and 
+! output of chosen solver in chem_parin added                          30.07.2018 ketelsen
+!
+! chem_check_data_output_pr: added unit for PM compounds               20.07.2018 forkel
+! replaced : by nzb+1:nzt for pt,q,ql (found by kk)                    18.07.2018 forkel
+! debugged restart run for chem species               06.07.2018 basit
+! reorganized subroutines in alphabetical order.      27.06.2018 basit
+! subroutine chem_parin updated for profile output    27.06.2018 basit
+! Added humidity arrays to USE section and tmp_qvap in chem_integrate  26.6.2018 forkel
+! Merged chemistry with with trunk (nzb_do and nzt_do in 3d output)    26.6.2018 forkel
+!
+! reorganized subroutines in alphabetical order.      basit 22.06.2018
+! subroutine chem_parin updated for profile output    basit 22.06.2018
+! subroutine chem_statistics added                  
+! subroutine chem_check_data_output_pr add            21.06.2018 basit
+! subroutine chem_data_output_mask added              20.05.2018 basit
+! subroutine chem_data_output_2d added                20.05.2018 basit
+! subroutine chem_statistics added                    04.06.2018 basit
+! subroutine chem_emissions: Set cssws to zero before setting values 20.03.2018 forkel
+! subroutine chem_emissions: Introduced different conversion factors 
+! for PM and gaseous compounds                                    15.03.2018 forkel
+! subroutine chem_emissions updated to take variable number of chem_spcs and
+! emission factors.                                               13.03.2018 basit
+! chem_boundary_conds_decycle improved.                           05.03.2018 basit
+! chem_boundary_conds_decycle subroutine added                    21.02.2018 basit
+! chem_init_profiles subroutines re-activated after correction    21.02.2018 basit
+! 
+! 
+! 3293 2018-09-28 12:45:20Z forkel
 ! Modularization of all bulk cloud physics code components
-! 
+!
 ! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
-! 
+!
 ! 3246 2018-09-13 15:14:50Z sward
 ! Added error handling for input namelist via parin_fail_message
-! 
+!
 ! 3241 2018-09-12 15:02:00Z raasch
 ! +nest_chemistry
@@ -130,5 +165,4 @@
 !>       turned off. Need to be fixed. bK
 !> @todo test nesting for chem spcs, was implemented by suehring (kanani)
-!> @todo subroutine set_const_initial_values to be taken out from chemistry_model_mod !bK.
 !> @todo chemistry error messages
 !> @todo Format this module according to PALM coding standard (see e.g. module
@@ -138,163 +172,310 @@
 !------------------------------------------------------------------------------!
 
-MODULE chemistry_model_mod
-
-   USE kinds,              ONLY: wp, iwp
-   USE indices,            ONLY: nz, nzb,nzt,nysg,nyng,nxlg,nxrg,nys,nyn
-   USE pegrid,             ONLY: myid, threads_per_task
-   USE control_parameters, ONLY: dt_3d, ws_scheme_sca, initializing_actions, message_string, &
-                                 omega, tsc, intermediate_timestep_count,      &
-                                 intermediate_timestep_count_max,              &
-                                 timestep_scheme, use_prescribed_profile_data  
-   USE arrays_3d,          ONLY: hyp, pt, rdf_sc, tend, zu, exner
-   USE chem_gasphase_mod,  ONLY: nspec, spc_names, nkppctrl, nmaxfixsteps,     &
-                                 t_steps, fill_temp, chem_gasphase_integrate,  &
-                                 nvar, atol, rtol, nphot, phot_names
-   USE cpulog,             ONLY: cpu_log, log_point
-
-   USE chem_modules
+ MODULE chemistry_model_mod
+    USE MPI
+
+    USE kinds,              ONLY: wp, iwp
+    USE indices,            ONLY: nz, nzb,nzt,nysg,nyng,nxlg,nxrg,                                 &
+                                 nys,nyn,nx,nxl,nxr,ny,wall_flags_0
+    USE pegrid,             ONLY: myid, threads_per_task
+
+   USE bulk_cloud_model_mod,                                               &
+        ONLY:  bulk_cloud_model
+
+    USE control_parameters, ONLY: bc_lr_cyc, bc_ns_cyc, dt_3d, humidity,                           &
+                                 initializing_actions, message_string,                             &
+                                 omega, tsc, intermediate_timestep_count,                          &
+                                 intermediate_timestep_count_max,                                  &
+                                 timestep_scheme, use_prescribed_profile_data, ws_scheme_sca  
+   USE arrays_3d,          ONLY: exner, hyp, pt, q, ql, rdf_sc, tend, zu
+    USE chem_gasphase_mod,  ONLY: nspec, spc_names, nkppctrl, nmaxfixsteps,                        &
+                                 t_steps, chem_gasphase_integrate, vl_dim,                         &
+                                 nvar, nreact,  atol, rtol, nphot, phot_names
+    USE cpulog,             ONLY: cpu_log, log_point
+
+    USE chem_modules
  
-
-   IMPLICIT   NONE
-   PRIVATE
-   SAVE
-
-   LOGICAL ::  nest_chemistry = .TRUE. !< flag for nesting mode of chemical species, independent on parent or not
+    USE statistics
+
+    IMPLICIT   NONE
+    PRIVATE
+    SAVE
+
+    LOGICAL ::  nest_chemistry = .TRUE. !< flag for nesting mode of chemical species, independent on parent or not
 !
 !- Define chemical variables
-   TYPE   species_def
-      CHARACTER(LEN=8)                                   :: name
-      CHARACTER(LEN=16)                                  :: unit
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_av
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_p
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: tconc_m
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: cssws_av           
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: flux_s_cs
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: diss_s_cs
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: flux_l_cs
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: diss_l_cs
-      REAL(kind=wp),ALLOCATABLE,DIMENSION(:)             :: conc_pr_init
-   END TYPE species_def
-
-
-   TYPE   photols_def                                                            
-      CHARACTER(LEN=8)                                   :: name
-      CHARACTER(LEN=16)                                  :: unit
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: freq
-   END TYPE photols_def
-
-
-   PUBLIC  species_def
-   PUBLIC  photols_def
-
-
-   TYPE(species_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: chem_species
-   TYPE(photols_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: phot_frequen  
-
-   REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_1
-   REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_2
-   REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_3
-   REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_av       
-   REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: freq_1
-
-   INTEGER,DIMENSION(nkppctrl)                           :: icntrl                            ! Fine tuning kpp
-   REAL(kind=wp),DIMENSION(nkppctrl)                     :: rcntrl                            ! Fine tuning kpp
-
-   CHARACTER(10), PUBLIC :: photolysis_scheme
+    TYPE   species_def
+       CHARACTER(LEN=8)                                   :: name
+       CHARACTER(LEN=16)                                  :: unit
+       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc
+       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_av
+       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: conc_p
+       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: tconc_m
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: cssws_av           
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: flux_s_cs
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:)           :: diss_s_cs
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: flux_l_cs
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:)         :: diss_l_cs
+       REAL(kind=wp),ALLOCATABLE,DIMENSION(:)             :: conc_pr_init
+    END TYPE species_def
+
+
+    TYPE   photols_def                                                            
+       CHARACTER(LEN=8)                                   :: name
+       CHARACTER(LEN=16)                                  :: unit
+       REAL(kind=wp),POINTER,DIMENSION(:,:,:)             :: freq
+    END TYPE photols_def
+
+
+    PUBLIC  species_def
+    PUBLIC  photols_def
+
+
+    TYPE(species_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: chem_species
+    TYPE(photols_def),ALLOCATABLE,DIMENSION(:),TARGET, PUBLIC     :: phot_frequen  
+
+    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_1
+    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_2
+    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_3
+    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: spec_conc_av       
+    REAL(kind=wp),ALLOCATABLE,DIMENSION(:,:,:,:),TARGET   :: freq_1
+
+    INTEGER,DIMENSION(nkppctrl)                           :: icntrl                            ! Fine tuning kpp
+    REAL(kind=wp),DIMENSION(nkppctrl)                     :: rcntrl                            ! Fine tuning kpp
+    LOGICAL :: decycle_chem_lr    = .FALSE.
+    LOGICAL :: decycle_chem_ns    = .FALSE.
+    CHARACTER (LEN=20), DIMENSION(4) ::  decycle_method = &
+                  (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
+                                 !< Decycling method at horizontal boundaries, 
+                                 !< 1=left, 2=right, 3=south, 4=north
+                                 !< dirichlet = initial size distribution and 
+                                 !< chemical composition set for the ghost and 
+                                 !< first three layers
+                                 !< neumann = zero gradient
+
+    REAL(kind=wp), PUBLIC :: cs_time_step
+    CHARACTER(10), PUBLIC :: photolysis_scheme
                                          ! 'constant',
                                          ! 'simple' (Simple parameterisation from MCM, Saunders et al., 2003, Atmos. Chem. Phys., 3, 161-180
                                          ! 'fastj'  (Wild et al., 2000, J. Atmos. Chem., 37, 245-282) STILL NOT IMPLEMENTED
 
-   PUBLIC nest_chemistry, nspec
-   PUBLIC nvar       
-   PUBLIC spc_names
-   PUBLIC spec_conc_2  
-
-!- Interface section
-  INTERFACE chem_boundary_conds
-      MODULE PROCEDURE chem_boundary_conds
-  END INTERFACE chem_boundary_conds
-
-   INTERFACE chem_init
-      MODULE PROCEDURE chem_init
-   END INTERFACE chem_init
-
-   INTERFACE chem_init_profiles
-      MODULE PROCEDURE chem_init_profiles
-   END INTERFACE chem_init_profiles
-
-   INTERFACE chem_parin
-      MODULE PROCEDURE chem_parin
-   END INTERFACE chem_parin
-
-   INTERFACE chem_integrate
-      MODULE PROCEDURE chem_integrate_ij
-   END INTERFACE chem_integrate
-
-   INTERFACE chem_swap_timelevel
-      MODULE PROCEDURE chem_swap_timelevel
-   END INTERFACE chem_swap_timelevel
-
-   INTERFACE chem_define_netcdf_grid
-      MODULE PROCEDURE chem_define_netcdf_grid
-   END INTERFACE chem_define_netcdf_grid
-
-   INTERFACE chem_data_output_3d
-      MODULE PROCEDURE chem_data_output_3d
-   END INTERFACE chem_data_output_3d
-
-   INTERFACE chem_check_data_output
-      MODULE PROCEDURE chem_check_data_output
-   END INTERFACE chem_check_data_output
-
-   INTERFACE chem_check_data_output_pr
-      MODULE PROCEDURE chem_check_data_output_pr
-   END INTERFACE chem_check_data_output_pr
-
-   INTERFACE chem_3d_data_averaging
-      MODULE PROCEDURE chem_3d_data_averaging 
-   END INTERFACE chem_3d_data_averaging
-
-   INTERFACE chem_wrd_local
-      MODULE PROCEDURE chem_wrd_local 
-   END INTERFACE chem_wrd_local
-
-   INTERFACE chem_rrd_local
-      MODULE PROCEDURE chem_rrd_local
-   END INTERFACE chem_rrd_local
-
-   INTERFACE chem_prognostic_equations
-      MODULE PROCEDURE chem_prognostic_equations
-      MODULE PROCEDURE chem_prognostic_equations_ij
-   END INTERFACE chem_prognostic_equations
-
-   INTERFACE chem_header
-      MODULE PROCEDURE chem_header
-   END INTERFACE chem_header
-
-   INTERFACE chem_emissions
-      MODULE PROCEDURE chem_emissions
-   END INTERFACE chem_emissions
-
-!    INTERFACE chem_wrd_global
-!       MODULE PROCEDURE chem_wrd_global
-!    END INTERFACE chem_wrd_global
-! 
-!    INTERFACE chem_rrd_global
-!       MODULE PROCEDURE chem_rrd_global
-!    END INTERFACE chem_rrd_global
-
-
-   PUBLIC chem_3d_data_averaging, chem_boundary_conds, chem_check_data_output, &
-          chem_check_data_output_pr, chem_data_output_3d,                      &
-          chem_define_netcdf_grid, chem_emissions, chem_header, chem_init,     &
-          chem_init_profiles, chem_integrate, chem_wrd_local,                  &
-          chem_parin, chem_prognostic_equations,                               &
-          chem_rrd_local, chem_swap_timelevel
+    PUBLIC nest_chemistry
+    PUBLIC nspec
+    PUBLIC nreact
+    PUBLIC nvar      
+    PUBLIC spc_names
+    PUBLIC spec_conc_2  
+
+!-  Interface section
+    INTERFACE chem_3d_data_averaging
+       MODULE PROCEDURE chem_3d_data_averaging 
+    END INTERFACE chem_3d_data_averaging
+
+    INTERFACE chem_boundary_conds
+       MODULE PROCEDURE chem_boundary_conds
+       MODULE PROCEDURE chem_boundary_conds_decycle
+    END INTERFACE chem_boundary_conds
+
+    INTERFACE chem_check_data_output
+       MODULE PROCEDURE chem_check_data_output
+    END INTERFACE chem_check_data_output
+
+    INTERFACE chem_data_output_2d
+       MODULE PROCEDURE chem_data_output_2d
+    END INTERFACE chem_data_output_2d
+
+    INTERFACE chem_data_output_3d
+       MODULE PROCEDURE chem_data_output_3d
+    END INTERFACE chem_data_output_3d
+
+    INTERFACE chem_data_output_mask
+       MODULE PROCEDURE chem_data_output_mask
+    END INTERFACE chem_data_output_mask
+
+    INTERFACE chem_check_data_output_pr
+       MODULE PROCEDURE chem_check_data_output_pr
+    END INTERFACE chem_check_data_output_pr
+
+    INTERFACE chem_check_parameters
+       MODULE PROCEDURE chem_check_parameters
+    END INTERFACE chem_check_parameters
+
+    INTERFACE chem_define_netcdf_grid
+       MODULE PROCEDURE chem_define_netcdf_grid
+    END INTERFACE chem_define_netcdf_grid
+
+    INTERFACE chem_header
+       MODULE PROCEDURE chem_header
+    END INTERFACE chem_header
+
+    INTERFACE chem_init
+       MODULE PROCEDURE chem_init
+    END INTERFACE chem_init
+
+    INTERFACE chem_init_profiles
+       MODULE PROCEDURE chem_init_profiles
+    END INTERFACE chem_init_profiles
+
+    INTERFACE chem_integrate
+       MODULE PROCEDURE chem_integrate_ij
+    END INTERFACE chem_integrate
+
+    INTERFACE chem_parin
+       MODULE PROCEDURE chem_parin
+    END INTERFACE chem_parin
+
+    INTERFACE chem_prognostic_equations
+       MODULE PROCEDURE chem_prognostic_equations
+       MODULE PROCEDURE chem_prognostic_equations_ij
+    END INTERFACE chem_prognostic_equations
+
+    INTERFACE chem_rrd_local
+       MODULE PROCEDURE chem_rrd_local
+    END INTERFACE chem_rrd_local
+
+    INTERFACE chem_statistics
+       MODULE PROCEDURE chem_statistics
+    END INTERFACE chem_statistics
+
+    INTERFACE chem_swap_timelevel
+       MODULE PROCEDURE chem_swap_timelevel
+    END INTERFACE chem_swap_timelevel
+
+    INTERFACE chem_wrd_local
+       MODULE PROCEDURE chem_wrd_local 
+    END INTERFACE chem_wrd_local
+
+
+    PUBLIC chem_3d_data_averaging, chem_boundary_conds, chem_check_data_output, &
+           chem_check_data_output_pr, chem_check_parameters,                    &
+           chem_data_output_2d, chem_data_output_3d, chem_data_output_mask,     &
+           chem_define_netcdf_grid, chem_header, chem_init,                     &
+           chem_init_profiles, chem_integrate, chem_parin,                      &
+           chem_prognostic_equations, chem_rrd_local,                           &
+           chem_statistics, chem_swap_timelevel, chem_wrd_local 
+
+
+
+ CONTAINS
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
+!> the averaged chem arrays are allocated in chem_init, no if-query concerning
+!> the allocation is required (in any mode). Attention: If you just specify an 
+!> averaged output quantity in the _p3dr file during restarts the first output
+!> includes the time between the beginning of the restart run and the first
+!> output time (not necessarily the whole averaging_interval you have 
+!> specified in your _p3d/_p3dr file )
+!------------------------------------------------------------------------------!
+
+    SUBROUTINE chem_3d_data_averaging ( mode, variable )
+
+       USE control_parameters
+
+       USE indices
+
+       USE kinds
+
+       USE surface_mod,                                                         &
+          ONLY: surf_def_h, surf_lsm_h, surf_usm_h   
+  
+       IMPLICIT NONE
+ 
+       CHARACTER (LEN=*) ::  mode    !< 
+       CHARACTER (LEN=*) :: variable !< 
+ 
+       LOGICAL      ::  match_def !< flag indicating natural-type surface
+       LOGICAL      ::  match_lsm !< flag indicating natural-type surface
+       LOGICAL      ::  match_usm !< flag indicating urban-type surface
+
+       INTEGER(iwp) ::  i                  !< grid index x direction
+       INTEGER(iwp) ::  j                  !< grid index y direction
+       INTEGER(iwp) ::  k                  !< grid index z direction
+       INTEGER(iwp) ::  m                  !< running index surface type
+       INTEGER(iwp) :: lsp                 !< running index for chem spcs
+
+
+       IF ( mode == 'allocate' )  THEN
+          DO lsp = 1, nspec
+             IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+                chem_species(lsp)%conc_av = 0.0_wp
+                
+             ENDIF
+          ENDDO
+
+       ELSEIF ( mode == 'sum' )  THEN
+
+
+          DO lsp = 1, nspec
+             IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                          chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) + &
+                                                             chem_species(lsp)%conc(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSEIF ( TRIM(variable(4:)) == TRIM('cssws*') )        THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <=               &
+                                  surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <=                  &
+                                  surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <=                  &
+                                  surf_usm_h%end_index(j,i)
+
+                      IF ( match_def )  THEN
+                         m = surf_def_h(0)%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                        &
+                                                chem_species(lsp)%cssws_av(j,i) + &
+                                                surf_def_h(0)%cssws(lsp,m)
+                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
+                         m = surf_lsm_h%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                        &
+                                                chem_species(lsp)%cssws_av(j,i) + &
+                                                surf_lsm_h%cssws(lsp,m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                        &
+                                                chem_species(lsp)%cssws_av(j,i) + &
+                                                surf_usm_h%cssws(lsp,m)
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDIF
+          ENDDO
+ 
+       ELSEIF ( mode == 'average' )  THEN
+          DO lsp = 1, nspec
+             IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                          chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             ELSEIF (TRIM(variable(4:)) == TRIM('cssws*') )            THEN
+                DO i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                        chem_species(lsp)%cssws_av(j,i) = chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                   CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
+             ENDIF
+          ENDDO
           
-
- CONTAINS
-
+       ENDIF     
+
+    END SUBROUTINE chem_3d_data_averaging
+
+!    
 !------------------------------------------------------------------------------!
 !
